/* ``The contents of this file are subject to the Erlang Public License,
 * Version 1.0, (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.erlang.org/EPL1_0.txt
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Erlang-4.7.3, December, 1998.
 * 
 * The Initial Developer of the Original Code is Ericsson Telecom
 * AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
 * Telecom AB. All Rights Reserved.
 * 
 * Contributor(s): ______________________________________.''
 */
/* Just include the interface function */
#include "rmod_random.h"


/* Assign your own node name here */
#define SNODE "babbis@balin"
#define SERVER "rmod_random_impl"
#define BUFSZ 32000
#define COOKIE "flash"
#define CLNODE "c47@balin"

/* Stopping node */
void kill(CORBA_Environment *env) {
  erl_close_connection(env->_fd);
  exit(1);
}

int main(){
  
  char buf[BUFSZ];
  double result=0;
  int i=0;
  erlang_pid pid;
  CORBA_Environment env;
  
  /* Initiating the connection */
  erl_init(NULL,0);
  erl_connect_init(47,COOKIE,0);

  /* Initiating pid*/
  strcpy(pid.node,CLNODE);
  pid.num = 99;
  pid.serial = 0;
  pid.creation = 0;

  /* Fixing environment variable */
  env._fd=erl_connect(SNODE);
  env._inbuf = buf;
  env._inbufsz = BUFSZ;
  env._outbuf = buf;
  strcpy(env._regname,SERVER);
  env._to_pid = NULL;
  env._from_pid = &pid;
  

  /* Calling the init function */
  rmod_random_init(NULL, 1, 2, 3, &env);
 
  switch(env._major) {
  case CORBA_NO_EXCEPTION: /* Success */
    printf("Init complete !\n");
    break;
  case CORBA_SYSTEM_EXCEPTION: /* System exception */
    printf("Init call failure, reason : %s\n",(char *) CORBA_exception_value(&env));
    CORBA_exception_free(&env);
    kill(&env);
  default: /* Should not come here */
    kill(&env);
  }

  /* Calling the produce function */
  for(i=1; i<=10; i++) {
    result = rmod_random_produce(NULL, &env);

    switch(env._major) {
    case CORBA_NO_EXCEPTION: /* Success */
      break;
    case CORBA_SYSTEM_EXCEPTION: /* System exception */
      printf("Init call failure, reason : %s\n",(char *) CORBA_exception_value(&env));
      CORBA_exception_free(&env);
      kill(&env);
    default: /* Should not come here */
      kill(&env);
    }

    printf("the random number nr%d is %f\n",i,result);
  }

  /* Closing the connection */
  erl_close_connection(env._fd);
  return 0;
}
