%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%%------------------------------------------------------------
%%
%% 
%%
%%
%%    COPYRIGHT Ericsson Telecom AB 1995
%%
%%    126 25 STOCKHOLM
%%    SWEDEN
%%    tel int + 46 8 719 0000
%%
%%    The copyright to the computer program herein is the property of
%%    Ericsson Telecom AB, Sweden. The program may be used and/or
%%    copied only with the written permission from Ericsson Telecom AB
%%    or in accordance with the terms and conditions stipulated in the
%%    agreement/contract under which the program have been supplied.
%%
%%
%%    Module documentation:
%%    ---------------------
%%
%%    Header file for the Erlang IDL compiler. Contains all records
%%    used in the parse tree
%%
%%
%%------------------------------------------------------------



%%------------------------------------------------------------

-record(module,		{id, body}).
-record(interface,	{id, inherit, body, inherit_body, tk}).
-record(forward,	{id, tk}).
-record(const,		{type, id, val, tk}).
-record(type_dcl,	{type, tk}).
-record(typedef,	{type, id, tk}).
-record(struct,		{id, body, tk}).
-record(member,		{type, id}).
-record(union,		{id, type, body, tk}).
-record(case_dcl,	{label, id, type}).
-record(enum,		{id, body, tk}).
-record(enumerator,	{id}).
-record(sequence,	{type, length=0}).
-record(string,		{length=0}).
-record(array,		{id, size}).
-record(attr,		{readonly, type, id, tk}).
-record(except,		{id, body, tk}).
-record(op,		{oneway, type, id, params, raises, ctx, tk}).
-record(param,		{inout, type, id, tk}).

%% NON-STANDARD
-record(preproc,	{cat, id, aux}).
-record(pragma,	        {type, to, apply}).










