/* ``The contents of this file are subject to the Erlang Public License,
 * Version 1.0, (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.erlang.org/EPL1_0.txt
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Erlang-4.7.3, December, 1998.
 * 
 * The Initial Developer of the Original Code is Ericsson Telecom
 * AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
 * Telecom AB. All Rights Reserved.
 * 
 * Contributor(s): ______________________________________.''
 */
#ifndef _BIN_H
#define _BIN_H

/* RCS: $Id: bin.h,v 1.4 1996/04/09 13:07:24 tobbe Exp $ */

#include "ig.h"

/* Test examples:
 *
 * 1> A=bin:start().
 * <0.11.0>
 * 2> {_,B}=bin:doom(A,list_to_binary("madonna")).
 *   doom: size = 7
 *   109  97  100  111  110  110  97 
 * {ok,#Bin}
 * 3> binary_to_list(B).
 * [1,2,3,4,5,6]
 * 4> {_,P}=bin:malloc(A,255).
 * {ok,43952}
 * 5> bin:put_binary(A,list_to_binary("A tedious string"),P).
 * ok
 * 6> {_,B2}=bin:get_binary(A,P,length("A tedious string")).
 * {ok,#Bin}
 * 7> binary_to_list(B2).
 * "A tedious string"
 */

#ifdef HIDE
typedef unsigned long size_t;
#endif

IG_fun void *malloc(size_t);

IG_fun IG_binaryPtr get_binary(unsigned char *buf, int len);
IG_void void put_binary(IG_binaryPtr chunk, char *bufp);

IG_fun IG_binaryPtr doom(IG_binaryPtr bin);

#endif
