/* ``The contents of this file are subject to the Erlang Public License,
 * Version 1.0, (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.erlang.org/EPL1_0.txt
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Erlang-4.7.3, December, 1998.
 * 
 * The Initial Developer of the Original Code is Ericsson Telecom
 * AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
 * Telecom AB. All Rights Reserved.
 * 
 * Contributor(s): ______________________________________.''
 */
#ifndef _POINTER_H
#define _POINTER_H

/* RCS: $Id: pointer.h,v 1.6 1996/04/09 13:21:44 tobbe Exp $ */

#include <stdlib.h>
#include "Superman.h"
#include "ig.h"

/* Test example:
 *
 *   1> Z=pointer:start().
 *   <0.11.0>
 *   2> {_,P}=pointer:malloc(Z,8).
 *   {ok,43872}
 *   3> pointer:free(Z,P).        
 *   ok
 *   4> {_,P1}=pointer:my_malloc(Z,8).
 *   {ok,43872}
 *   5> {_,P2}=pointer:malloc(Z,8).   
 *   {ok,43904}
 */

#ifdef HIDE
typedef long unsigned int size_t;
#endif

IG_fun void *malloc(size_t size);
IG_void void free(void *ptr);

IG_fun Superman my_malloc(size_t size);

#endif

