%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%%%----------------------------------------------------------------------
%%% File    : ir_types.hrl
%%% Author  : Per Danielsson <pd@gwaihir>
%%% Purpose : Record definitions for structs used in the interface repository
%%% Created :  7 May 1997 by Per Danielsson <pd@gwaihir>
%%%----------------------------------------------------------------------


%%%----------------------------------------------------------------------
%%% *********************************************************************
%%% *									*
%%% *                        PLEASE NOTE				*
%%% *									*
%%% * If a record is removed or added in this file, select/2 in		*
%%% * orber_ifr.erl _MUST_ be updated accordingly.			*
%%% *									*
%%% *********************************************************************
%%%----------------------------------------------------------------------

-record(contained_description, {kind, value}).

-record(structmember, {name, type, type_def}).

-record(unionmember, {name, label, type, type_def}).

-record(container_description, {contained_object, kind, value}).

-record(moduledescription, {name, id, defined_in, version}).

-record(constantdescription, {name, id, defined_in, version, type, value}).

-record(typedescription, {name, id, defined_in, version, type}).

-define(make_typedescription(Obj,Object_type),
	#typedescription{name = Obj#Object_type.name,
			 id = Obj#Object_type.id,
			 defined_in = Obj#Object_type.defined_in,
			 version = Obj#Object_type.version,
			 type = Obj#Object_type.type}.

-record(exceptiondescription, {name, id, defined_in, version, type}).

-record(attributedescription, {name, id, defined_in, version, type, mode}).

-record(parameterdescription, {name, type, type_def, mode}).

-record(operationdescription, {name, id, defined_in, version, result, mode,
			       contexts, parameters, exceptions}).

-record(fullinterfacedescription, {name, id, defined_in, version, operations,
				   attributes, base_interfaces, type}).

-record(interfacedescription, {name, id, defined_in, version,
			       base_interfaces}).
