%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%% File: exref_state.hrl
%% Author: Joakim Hirsch
%% Description:
%%
%% Definition of the data type state.
%%
-record(state, {
		fgraph = nograph,     %% function call graph
		mgraph = nograph,     %% module graph
		includes = [],        %% include file path list
		excludes = [],        %% exclude module list
		defs = [],            %% epp pre defs
	        module = undefined,   %% current module
	        auto = undefined,     %% modules to auto include
	        file = undefined,     %% current file
	        imports = undefined,  %% imports in module
	        exports = undefined,  %% exports in module
	        options = undefined,  %% exref options
	        modules = [],         %% list of modules in graph (global)
	        paths = [],           %% list of tuples, {AbsolutePath, Module}.
	                              %% Used to be able to reload correct modules
	                              %% after a delete module operation has been
	                              %% performed on another module (which is
	                              %% done by deleting all and then reloading
	                              %% some).
                failed = []           %% List of modules which couldn't be loaded.
	  }).
